;-------------------------------------------------
;Z80 DISASSEMBLER LISTING
;Label  Instruction
;-------------------------------------------------
;4 mhz clock,1834 uart clock,  8k rom, 8k ram
;PORT 00: data, port 01 control/status
;4 input,  5 and 6 output
;
.org 0000H

        LD SP,3F00H  ; STACK AT THE END OF 8K RAM
        IM 1
	;EI
	DI

INIT8251:	

        LD A,040H            
        OUT (001H),A  
        NOP
	NOP  
        LD A,040H            
        OUT (001H),A
	NOP
	NOP  
                  
        LD A,040H            
        OUT (001H),A  ; WORST CASE INIT
	NOP
	NOP
	
	
	
        LD A,040H            
        OUT (001H),A  		; RESET 8251
        NOP
	NOP

        LD A,04EH            
        OUT (001H),A      	 ; 8-N-1  CLK/1  4EH FOR /16, 4D FOR /1  (MODE )
        NOP
	NOP    
        LD A,037H            
        OUT (001H),A      	 ; RESET ALL ERROR FLAGS AND ENABLE RXRDY,TXRDY (COMMAND)
        
     


	JP GREET
	
	
	
        .ORG 0038H
INERRUPT:
	DI
	
	;LD A,040H            
        ;OUT (001H),A  		; RESET 8251
        ;CALL DELAY_Y

        ;LD A,04DH            
        ;OUT (001H),A      	 ; 8-N-1  CLK/1 (MODE ) (4EH FOR /16, 4D FOR /1)
        ;NOP  
   
        ;LD A,037H            
        ;OUT (001H),A      	 ; RESET ALL ERROR FLAGS AND ENABLE RXRDY,TXRDY (COMMAND)
        ;NOP 
	
        
	CALL DELAY_Y

	CALL RXD

        
	CALL TXD
	EI
	RETI
       

		
GREET:	             ;READY SEND FILE MSG
	LD HL,TABLE
	LD B,85   ; DECIMAL IF NOT H AT THE END
DIS:	LD A,(HL)
	CALL TXD
        INC HL
	DJNZ DIS
	
	
	JP INTLIN1
	
LOAD_ED:	              ; FILE LOADED MESAGE
	LD HL,TABLE2
	LD B, 43
DIS2:	LD A,(HL)
	CALL TXD
        INC HL
	DJNZ DIS2
	
	
RUN_1:  CALL RXD	;LOAD HEX FILE AND WAIT ENTER TO RUN 2000H
	CP 00DH
	JP Z, 2000H

	
	JP RUN_1
	
	
TABLE: 	.DB 0AH,0DH
	.DB 'EfexMon '
	.DB 'By M.PEKER '
        .DB '18.3.2017'

	.DB 0AH,0DH
	.DB 'TXD:106H'
	.DB 0AH,0DH
	.DB 'RXD:11CH'
	.DB 0AH,0DH
        .DB 0AH,0DH 
	.DB 'Ready>'
	.DB 0AH,0DH
	.DB 'PLEASE '
	.DB 'SEND '
	.DB 'HEX '
	.DB 'FILE !'
	.DB 07H
	
	

	
TABLE2: .DB 0AH,0DH
	.DB 'FILE '
	.DB 'LOADED '
        .DB 'PRESS '
	.DB 'ENTER '
	.DB 'TO RUN '
	.DB '2000H !'
	.DB 0AH,0DH,07H

	
	

				
			
	
BLINK:
           LD A,000H            
        OUT (008H),A  
        CALL DELAY_Y

         LD A,0FFH            
        OUT (008H),A  
        CALL DELAY_Y
        JP BLINK
 
	
DELAY_Y:  
	LD DE,03030H  
LOOP_DEX:  DEC DE
        LD A,D
        OR E
        JP NZ,LOOP_DEX
        RET

	
		

	


	
		


;TXD ROUTINE sends contents of A REGISTER  to serial out pin 
;2400 BAUD, 8-N-1


TXD:    PUSH AF
LOPTX: 	IN A,(01H)
	AND 001H     ;TXRDY?
	JP Z, LOPTX
        POP AF
	OUT (00H),A
                   
	RET




DELAY_X:  LD DE,0060H ; SHORT DELAY 
LOOP_DX:  DEC DE
        LD A,D
        OR E
        JP NZ,LOOP_DX
        RET

;RXD ROUTINE receives 1 bayt from serial INPUT pin to A REGISTER AND 0F30H adress
;2400 BAUD, 8-N-1

RXD:    
	LD A,037H
	OUT (01),A ;ENABLE TX AND RX AND CLEAR ERR BITS
	
LOPTR: 	IN A,(01H)
	AND 002H     ;TXRDY?
	JP Z, LOPTR
        IN A,(00H)   ;RECEIVE CHAR
	RET
	
	

;	*********************************
;	*				*
;	*     Get Intel hex record	*
;	*				*
;	*********************************

;Short version - no checksum calculation.

INTLIN1:	
	LD A,000H
	LD (3F31H),A
INTLIN:	CALL	RXD		;Get chr
	CP	':'		;Is it ':'?
	JR	NZ,INTLIN	;If not then next
	CALL	BYTERD		;Get record length
	LD	B,A		;Put in B
	CALL	BYTERD		;Get record address hi byte
	LD	H,A		;Put in H
	CALL	BYTERD		;Get record address lo byte
	LD	L,A		;Put in L
	LD A,(3F31H)		;CHECK IF HL RECORDED TO DISPLAY SOURCE ADRESS BEFORE?
	CP 01                   ;IF NOT, RECORD IT. OTHERWISE GO ON
	JP Z,GO_ON
	LD A,001H
	LD (3F31H),A
	LD (3F01H),HL	; LOADED PROGRAM START ADRESS FOR EFEX  DISPLAY POINTER
	
GO_ON:	CALL	BYTERD		;Record type(NOT IGNORED IN EFEX MON)
	CP 01                   ;IF END OF FILE THEN EXIT PROGRAM
	JP Z,LOAD_ED             ;  PROGRAM ENDED JUMP TO EXIT
	
	
DATAIN:	CALL	BYTERD		;Get record data byte
	LD	(HL),A		;Save byte to memory
	INC	HL		;Next address
	DJNZ	DATAIN		;Decrement count and jump if not finished
	JR	INTLIN		;Ignore checksum byte and [CR][LF]
	
	RET		;

BYTERD:	LD	D,000h		;Set up   ;	* Get 2 ASCII chrs as hex byte	*
	CALL	HEXCON		;Get byte and convert to hex
	ADD	A,A		;First nibble so
	ADD	A,A		;multiply by 16
	ADD	A,A		;
	ADD	A,A		;
	LD	D,A		;Save hi nibble in D
HEXCON:	CALL	RXD		;Get next chr
	SUB	030h		;Makes '0'-'9' equal 0-9
	CP	00Ah		;Is it 0-9 ?
	JR	C,NALPHA	;If so miss next bit
	SUB	007h		;Else convert alpha
NALPHA:	OR	D		;Add hi nibble back
	RET			;


;,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
;INTEL HEX SAVE PROGRAM         ;
;,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
;	LD HL,START ADRESS
;	LD DE, END ADRESS
	
INTSAVE:
	PUSH HL
	EX DE,HL
	SBC HL,DE
	EX DE,HL
	POP HL
	LD A,0
	LD (3F34H),A	;RESET CHECKSUM COUNTER
	LD B,10H
	
	LD A,0DH		;ENTER
	CALL TXD ;TXD ROUTINE
	LD A,0AH
	CALL TXD ;TXD ROUTINE
	
COMP:	LD A,D	; DE TEK BAYTA INMIS
	CP 0
	JP Z, MINUS
	JP DONGU
	
MINUS:	LD A,E      ;E 10H TAN KUCUKSE..
	SUB 10H
	JP C,MINIMUS
	JP DONGU
	
MINIMUS: LD B,E    ;DE 10H TAN AZ
	JP DONGU1 
	
DONGU:	LD B,10H
DONGU1:	LD A,':'
	CALL TXD ;TXD ROUTINE		;SEND START CODE
	LD A,B
	CALL HEXOUT		;SEND BYTE COUNT (DEFAULT 16)
	
	LD A,H 			;SEND RECORD ADRESS
	CALL HEXOUT
	LD A,L
	CALL HEXOUT
	
	LD A,0 			;SEND RECORD TYPE (0=DATA)
	CALL HEXOUT
	
	CALL YAZ
	LD A,D		;DE BYTE COUNT REACHED?
	OR E
	JP NZ, COMP
	
	LD A,':'		;ENDING COLON
	CALL TXD ;TXD ROUTINE		
	LD B,07H
DISEND:	LD A,'0'
	CALL TXD ;TXD ROUTINE
	DJNZ DISEND
	LD A,'1'
	CALL TXD ;TXD ROUTINE
	LD A,0FFH
	CALL HEXOUT
	
	JP GREET

	
	
	
	
YAZ:	LD A,(HL)
	CALL HEXOUT
	INC HL
	DEC DE
	DJNZ YAZ		;16 BYTES SENDED
	LD A, 0FFH		;SEND FAKE CHECKSUM
	CALL HEXOUT
	
	LD A,0DH		;ENTER
	CALL TXD ;TXD ROUTINE
	LD A,0AH
	CALL TXD ;TXD ROUTINE
	RET
		

	

;HEXOUT DO NOT CHANGES ANY REGISTER	
HEXOUT:	PUSH BC ; THIS SUBROUTINE SENDS CONTENTS OF ACC TO TERMINAL AS 
	PUSH DE ; TWO CHAR HEX VALUE (ASCII) 
	PUSH HL
	PUSH AF
	
	AND 0F0H
	RRA
	RRA
	RRA
	RRA
	LD (3F33H),A  ;HIGH NIBBLE SYSTEM VARIABLE
	CALL HEXAS
	
	POP AF
	PUSH AF
	AND 00FH
	LD (3F32H),A  ;LOW NIBBLE SYSTEM VARIABLE
	CALL HEXAS
	
	POP AF
	POP HL
	POP DE
	POP BC
	
	RET
	
HEXAS:	LD HL, TABLEX ; HEX NIBBLE TO ASCII CONVERTER
	LD  B, 0	;ADDING HL WITH A
	LD  C, A
	ADC HL, BC
       	LD A,(HL)
	CALL TXD ;TXD ROUTINE
	RET	
TABLEX:	.DB '0','1','2','3','4','5','6','7'
	.DB '8','9','A','B','C','D','E','F'

.end

.end





